-- ******************************** Variables *******************************
local L = LibStub("AceLocale-3.0"):GetLocale("Titan", true)
local LB = LibStub("AceLocale-3.0"):GetLocale("TitanPals", true)
-- ******************************** Functions *******************************
function TitanPanelPals_CoreUtils(b, b1, b2, b3, b4, b5, b6, b7, b8, b9, b10)
     if ( TitanPals["Debug"] ) then
          if ( b ) then TitanPals["dLine"] = "[|cffff9900"..b.."|r]" end
          if ( b1 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b1.."|r]" end
          if ( b2 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b2.."|r]" end
          if ( b3 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b3.."|r]" end
          if ( b4 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b4.."|r]" end
          if ( b5 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b5.."|r]" end
          if ( b6 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b6.."|r]" end
          if ( b7 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b7.."|r]" end
          if ( b8 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b8.."|r]" end
          if ( b9 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b9.."|r]" end
          if ( b10 ) then TitanPals["dLine"] = TitanPals["dLine"].."[|cff808080"..b10.."|r]" end
          TitanPals["dLine"] = "Recieved "..TitanPals["dLine"];
	  TitanPanelPals_DebugUtils("bug", "dLine", TitanPals["dLine"])
     end
     if ( b == "UpDate" ) then
          -- [b     ][b1     ][b2   ][b3    ]
          -- [Action][Faction][Realm][Player]

          local NumPals = GetNumFriends();
	  local NumPalsOnline = 0;
	  local Palsn, Palsl, Palsc, Palsa, Palsco, Palss, Palsno
	  local friendIndex, iTable
	  local cIndex = TitanPals["cIndex"];
	  local iT = {};
	  for friendIndex=1, NumPals do
	      --[Name][Level][Class][Area][Connected][Status][Note]
	      Palsn, Palsl, Palsc, Palsa, Palsco, Palss, Palsno = GetFriendInfo(friendIndex);
	      -- Test for new style database
              if ( not Palsno ) then iTable = Palsn..":"..Palsl..":"..Palsc..":"..Palsa..":nil"
              else iTable = Palsn..":"..Palsl..":"..Palsc..":"..Palsa..":"..Palsno end
	      tinsert(iT, iTable)
	  end
          iT["Name"] = b3;
	  if ( TitanPals["Lists"][b1][b2][cIndex] and TitanPals["Lists"][b1][b2][cIndex]["Name"] ) then tremove(TitanPals["Lists"][b1][b2], cIndex); end
	  tinsert(TitanPals["Lists"][b1][b2], cIndex, iT);
     elseif ( b == "NamePlate" ) then
          if ( status ) then status = status.." "; end;
          if (level == 0) then level = "-"; end
          if ( TitanPals["ShowClass"] ) then
               return "  "..status.." ("..TitanPanelPals_ColorUtils("GetCText", "orange", level).." "..TitanPanelPals_ColorUtils("GetCClass", "color", class, class)..") "..name;
          else
               return "  "..status.."("..TitanPanelPals_ColorUtils("GetCText", "orange", level)..") "..TitanPanelPals_ColorUtils("GetCClass", "color", class, name);
          end
     elseif ( b == "Toggle" ) then
          if ( TitanPals[b1] ) then 
	       TitanPals[b1] = false;
	       if ( b1 == "DebugLogEvent" ) then wipe(TitanPals["Temp"]); end
	       if ( b1 == "Debug") then TitanPals["dLine"] = ""; end
          elseif ( not TitanPals[b1] ) then TitanPals[b1] = true; end
     elseif ( b == "mem" ) then
	UpdateAddOnMemoryUsage();
	TitanPals["dLine"] = TitanPanelPals_ColorUtils("GetCText", "green", floor(GetAddOnMemoryUsage('TitanPals')).."kb");
	TitanPanelPals_DebugUtils("info", "mem", "Titan Panel [|cffeda55fPals|r] is using "..TitanPals["dLine"].." of memory");
     elseif ( b == "GetcIndex" ) then
          if ( not TitanPals["Lists"][b1][b2] ) then TitanPals["Lists"][b1][b2] = {}; end
	  local cTable = TitanPals["Lists"][b1][b2];
          local control = table.getn(cTable);
	  TitanPanelPals_DebugUtils("bug", "GetcIndex", "Table Index #"..control)
          local cIndex = 0;
	  if ( control == 0 ) then
	        TitanPals["cIndex"] = 1; TitanPanelPals_DebugUtils("bug", "GetcIndex", "cIndex(NewDB) = "..TitanPals["cIndex"]);
	  else
               for i=1, control do
	            if ( cTable[i]["Name"] == b3 ) then 
	                 cIndex = i; TitanPals["cIndex"] = cIndex;
		         TitanPanelPals_DebugUtils("bug", "GetcIndex", "Player Index = "..TitanPals["cIndex"]);
                    end
               end
               if ( cIndex == 0 ) then  cIndex = control+1; TitanPals["cIndex"] = cIndex; TitanPanelPals_DebugUtils("bug", "GetcIndex", "cIndex(NewPlayer) = "..TitanPals["cIndex"]); end
	  end
     elseif ( b == "playList" ) then
          local pTable = TitanPals["Temp"];
          for i=1, table.getn(pTable) do
	       TitanPanelPals_DebugUtils("info", "playList", pTable[i]);
          end
     elseif ( b == "addAlt" ) then
          local aIndex = TitanPals["cIndex"];
	  if ( not TitanPals["Alts"][b1] ) then TitanPals["Alts"][b1] = {}; end
	  if ( not TitanPals["Alts"][b1][b2] ) then TitanPals["Alts"][b1][b2] = {}; end
          local aTable = TitanPals["Alts"][b1][b2];
	  if ( not aTable[aIndex] or aTable[aIndex] ~= b3 ) then
	       TitanPanelPals_DebugUtils("bug", "addAlt", "Adding Alt ("..aIndex..") "..b3);
	       tinsert(TitanPals["Alts"][b1][b2], b3); 
	  elseif ( aTable[aIndex] == b3 ) then 
	       TitanPanelPals_DebugUtils("bug", "addAlt", "Found Alt "..aTable[aIndex]);
	       tremove(TitanPals["Alts"][b1][b2], aIndex);
	       tinsert(TitanPals["Alts"][b1][b2], aIndex, b3);
	  end
     elseif ( b == "sArgs" ) then
	local list = {};
	local a,b,c,d,e;
	for w in string.gmatch(b1, "(.*):(.*):(.*):(.*):(.*)") do 
		table.insert(list,w) 
	end
	if ( list[1] ) then a = list[1]; end
	if ( list[2] ) then b = list[2]; end
	if ( list[3] ) then c = list[3]; end
	if ( list[4] ) then d = list[4]; end
	if ( list[5] ) then e = table.concat(list," ",5); end
	return a,b,c,d,e;
     end
end

function TitanPanelPals_DebugUtils(d, d1, d2)
--     TitanPals["dLine"] = "";
--     TitanPals["Temp"] = {};
     if ( d == "bug" and TitanPals["Debug"] ) then
               local iDebug = TitanPanelPals_ColorUtils("GetCText", "red", LB["TITAN_PALS_DEBUG"]);
               DEFAULT_CHAT_FRAME:AddMessage(iDebug.."["..TitanPanelPals_ColorUtils("GetCText", "orange", d1).."] "..d2);
	       if ( TitanPals["DebugLogEvent"] ) then
	            if ( d1 ~= "dLine" ) then tinsert(TitanPals["Temp"], d2); end
	       end
     elseif ( d == "info" ) then
          local iInfo = TitanPanelPals_ColorUtils("GetCText", "orange", LB["TITAN_PALS_INFO"]);
	  DEFAULT_CHAT_FRAME:AddMessage(iInfo..d2);
     end
end

function TitanPanelPals_ColorUtils(c, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10)
     if ( c == "GetCText") then
          --[c     ][c1   ][c2  ]
          --[Action][Color][Text]
          if ( c1 == "gray" ) then return LB["GRAY_FONT_COLOR_CODE"]..c2..FONT_COLOR_CODE_CLOSE;
          elseif ( c1 == "red") then return RED_FONT_COLOR_CODE..c2..FONT_COLOR_CODE_CLOSE;
          elseif ( c1 == "green" ) then return GREEN_FONT_COLOR_CODE..c2..FONT_COLOR_CODE_CLOSE;
          elseif ( c1 == "orange") then return LB["ORANGE_FONT_COLOR_CODE"]..c2..FONT_COLOR_CODE_CLOSE;
          elseif ( c1 == "normal" ) then return NORMAL_FONT_COLOR_CODE..c2..FONT_COLOR_CODE_CLOSE;
          elseif ( c1 == "hlight" ) then return TitanUtils_GetHighlightText(c2) end
     elseif ( c == "GetCClass" ) then
          --[c     ][c1   ][c2   ][c3    ]
          --[Action][Style][Class][Player]
          local colorCode;
          if (c2 == "Warlock") then colorCode = "|cff9482C9";
          elseif (c2 == "Death Knight") then colorCode = "|cffc41f3b";
          elseif (c2 == "Hunter") then colorCode = "|cffabd473";
          elseif (c2 == "Priest") then colorCode = "|cffffffff";
          elseif (c2 == "Paladin") then colorCode = "|cfff58cba";
          elseif (c2 == "Mage") then colorCode = "|cff69ccf0";
          elseif (c2 == "Rogue") then colorCode = "|cfffff569";
          elseif (c2 == "Druid") then colorCode = "|cffff7d0a";
          elseif (c2 == "Shaman") then colorCode = "|cff2459FF";
          elseif (c2 == "Warrior") then colorCode = "|cffc79c6e";
          else colorCode = "|cffFFFFFF";
          end
          if ( c1 == "color" ) then return colorCode..c3..FONT_COLOR_CODE_CLOSE;
          elseif ( c1 == "normal" ) then return c3; end
     end
end

-- **************************************************************************
-- NAME : palsWisper()
-- DESC : Opens a wisper with the selected person
-- **************************************************************************
function palsWisper()
	if ( not ChatFrameEditBox:IsVisible() ) then
		ChatFrame_OpenChat("/w "..this.value.." ");
	else
		ChatFrameEditBox:SetText("/w "..this.value.." ");
	end
end